﻿'Name BbZuFunc
Public Class Form1
    Const size_w As Integer = 400             '描画幅
    Const size_h As Integer = 400             '描画高さ
    Const size_w2 As Integer = size_w / 2
    Const size_h2 As Integer = size_h / 2
    Const toRad As Double = Math.PI / 180.0   '度→ラジアン変換比率
    Dim ptrn As Integer = 0                   '描画パターン選択

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim cos30 As Double = Math.Cos(30.0 * toRad)   '30は視点の水平方向の回転角度
        Dim sin30 As Double = Math.Sin(30.0 * toRad)
        Dim cos_30 As Double = Math.Cos(-30.0 * toRad) '-30は視点の垂直方向の回転角度
        Dim sin_30 As Double = Math.Sin(-30.0 * toRad)
        Dim x, y, z As Double                          '3次元のグラフ座標
        Dim pointX, pointY As Integer                  'PictureBox上の2次元座標
        Dim i As Integer
        Dim minY(size_w), maxY(size_w) As Integer      'max･min用
        Dim g As System.Drawing.Graphics = PictureBox1.CreateGraphics()

        g.Clear(PictureBox1.BackColor)                 'クリア
        ptrn = ptrn + 1 : If ptrn > 2 Then ptrn = 1 '描画パターン選択

        For i = 0 To size_w                            '陰線処理用配列の初期化
            minY(i) = size_h
            maxY(i) = 0
        Next

        For z = -size_w2 To size_w2 Step 4
            For x = -size_w2 To size_w2
                y = GetYPos(x, z)                      'x,zからy値を求める

                '3次元から2次元平面への投影のX軸要素
                pointX = CInt(x * cos_30 + z * sin_30 + size_w2)
                If pointX < 0 Or size_w < pointX Then Continue For

                '3次元から2次元平面への投影のY軸要素
                pointY = CInt(y * cos30 - (z * cos_30 - x * sin_30) * sin30 + size_h2)

                '陰線処理
                If pointY < minY(pointX) Then          '描画可能なら
                    minY(pointX) = pointY
                    g.FillRectangle(Brushes.Black, pointX + 10, pointY, 1, 1)
                End If
                If pointY > maxY(pointX) Then          '描画可能なら
                    maxY(pointX) = pointY
                    g.FillRectangle(Brushes.Black, pointX + 10, pointY, 1, 1)
                End If
            Next
        Next
    End Sub

    'x,zを受けとり三次元式にもとづきy値を得る
    'Return文の先頭の「-」は数学とPictureBoxとでY軸の向きが逆のため
    Private Function GetYPos(ByVal x As Double, ByVal z As Double) As Double
        Dim rr As Double

        rr = x * x + z * z
        If ptrn = 1 Then
            Return -50 * Math.Sin(5 * Math.Sqrt(rr) * toRad)
        ElseIf ptrn = 2 Then
            Return -30 * (Math.Cos(Math.Sqrt(rr) * toRad) + Math.Cos(4 * Math.Sqrt(rr) * toRad))
        End If
    End Function
End Class
