﻿'Name BbZuTree
Public Class Form1
    Const XSIZE As Integer = 250        'ツリー描画全体の横サイズ
    Const YSIZE As Integer = 200        'ツリー描画全体の縦サイズ
    Const LENGTH As Integer = 50        '最初の枝の長さ
    Dim g As Graphics

    '[ツリー描画]ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim n As Integer                '枝の開く角度180/nを決める
        Dim deg As Double               '枝の伸びていく基準方向の角度
        Dim kaido As Double             '枝の開度を決める
        Dim x, y As Integer             '枝別れの位置

        g = PictureBox1.CreateGraphics()
        g.Clear(PictureBox1.BackColor)  '領域クリア
        n = 4                           '枝の開く角度(開度)を180/4=45度にする
        kaido = 180 / n                 'nを3～の値に変更すると絵柄も変化する
        x = XSIZE / 2 : y = YSIZE / 3   '最初の枝別れの位置
        deg = 180 / 2                   '枝の伸びていく方向を決める
        g.DrawLine(Pens.Black, x, YSIZE, x, YSIZE - y) '最初の幹を表示
        tree(x, y, LENGTH, deg, kaido)  '枝を表示
    End Sub

    Private Sub tree(ByVal x As Integer, ByVal y As Integer, ByVal lenn As Double, ByVal deg As Double, ByVal kaido As Double)
        Dim x1, x2, y1, y2 As Integer
        Dim deg_R As Double             '右の枝の角度
        Dim deg_L As Double             '左の枝の角度

        If lenn <= LENGTH / 15 Then Exit Sub '枝の込み具合を決める
        lenn = lenn * 0.75              '次第に枝が短くなる
        deg_R = deg - kaido             '右の枝の角度
        deg_L = deg + kaido             '左の枝の角度

        x1 = x + lenn * Math.Cos(deg_R * Math.PI / 180) '枝先の位置
        y1 = y + lenn * Math.Sin(deg_R * Math.PI / 180)
        x2 = x + lenn * Math.Cos(deg_L * Math.PI / 180)
        y2 = y + lenn * Math.Sin(deg_L * Math.PI / 180)

        g.DrawLine(Pens.Black, x, YSIZE - y, x1, YSIZE - y1) '右の枝(幹)を描画
        tree(x1, y1, lenn, deg_R, kaido)                     '右の枝の先を描画
        g.DrawLine(Pens.Black, x, YSIZE - y, x2, YSIZE - y2) '左の枝(幹)を描画
        tree(x2, y2, lenn, deg_L, kaido)                     '左の枝の先を描画
    End Sub
End Class
